;
(function () {
    if (window.PKBridge) {
        return;
    }

    // 外部注册进来 要调用js的那个方法
    var messageHandlers = {};
    var responseCallbacks = {};// 标记此次js调用Native的逻辑，完成之后，接收native发送给js的数据
    var uniqueId = 1;
    var dispatchMessagesWithTimeoutSafety = true;
    var random = 1;

    function _doSend(message, responseCallback) {
        if (responseCallback) {
            // h5响应的回调
            var callbackId = 'cb_' + (uniqueId++) + '_' + new Date().getTime();
            responseCallbacks[callbackId] = responseCallback; // 通过callbackId标识此次js发起的请求
            message['callbackId'] = callbackId; // 为message对象增加字段属性
        }

        var msg=JSON.stringify(message || {});
        if(window.WVJBInterface){
        // WVJBInterface 为外部注册进来的对象
           WVJBInterface.notice(msg); // WVJBInterface为Native注册进来的Native对象
        }else{
          prompt("_wvjbxx",msg);
        }
    }

    // 全局的bridge对象
    var bridge = {
        registerHandler: function (handlerName, handler) {
        // js中注册的回调
            messageHandlers[handlerName] = handler;
        },

        // js 回应给Native，而这约定相同的method Name
        callHandler: function (handlerName, data, responseCallback) {
            if (arguments.length == 2 && typeof data == 'function') {
                responseCallback = data;
                data = null;
            }

            // js发送信息到Native
            _doSend({
                handlerName: handlerName,
                data: data
            }, responseCallback);
        },
        disableJavascriptAlertBoxSafetyTimeout: function (disable) {
            this.callHandler("_disableJavascriptAlertBoxSafetyTimeout", disable !== false)
        },

        // 所有承接成Native过来的信息
        _handleMessageFromJava: function (messageJSON) {
            _dispatchMessageFromJava(messageJSON);
        },

        hasNativeMethod: function (name, responseCallback) {
            this.callHandler('_hasNativeMethod', name, responseCallback);
        }
    };

    bridge.registerHandler('_hasJavascriptMethod', function (data, responseCallback) {
        responseCallback(!!messageHandlers[data])
    })

    // js中分发信息
    function _dispatchMessageFromJava(message) {
        var messageHandler;
        var responseCallback;
        if (message.responseId) { // message.responseId就是_d0Send()前边塞进去的 message['callbackId'] = callbackId;
            responseCallback = responseCallbacks[message.responseId]; // 实际上Native透传了前边js注册的 message['callbackId'] = callbackId
            if (!responseCallback) {
                return;
            }
            responseCallback(message.responseData); // 此处的responseCallback对象是js业务自己定义的。此处触发responseCallback回调
            delete responseCallbacks[message.responseId]; // 删除本次回调
        } else {
            // Native 发起的
            if (message.callbackId) {
                var callbackResponseId = message.callbackId;
                responseCallback = function (responseData) {
                 // 此处的CallBack是JS处理完成之后，向Native层发起的回调函数。表示js处理完这个请求，回调给Native
                    _doSend({
                        handlerName: message.handlerName,
                        responseId: callbackResponseId,
                        responseData: responseData
                    });
                };
            }
            var handler = messageHandlers[message.handlerName]; // handler为注册进来的方法
            if (!handler) {
                console.log("PKBridge: WARNING: no handler for message from java", message);
            } else {
            // 调用JS中维护的方法。
                handler(message.data, responseCallback);
            }
        }
    }

    var callbacks = window.WVJBCallbacks;
    delete window.WVJBCallbacks;
    if (callbacks) {
        for (var i = 0; i < callbacks.length; i++) {
            callbacks[i](bridge);
        }
    }
    window.PKBridge = bridge;

    window.close=function(){
      bridge.callHandler("_closePage")
    }

})();